var active = true;

function updateTabs() {
    chrome.tabs.query({}, function(tabs) {
        tabs.forEach(function(tab) {
            chrome.tabs.sendMessage(tab.id, { event: "update", status: active });    
        });        
    });    
}

chrome.browserAction.onClicked.addListener(function(tab) {
    if (active) {
        active = false;
        chrome.browserAction.setIcon({ path: "kitty_key_off.png" });
    } else {
        active = true;
        chrome.browserAction.setIcon({ path: "kitty_key_on.png" });        
    }
    
    chrome.storage.sync.set({"status": active});
    
    updateTabs();
});

chrome.runtime.onMessage.addListener(function(obj, sender, sendResponse) {
    if (obj.type == "getStatus") {    
        sendResponse({ status: active });
    }
});

updateTabs();

chrome.storage.sync.get("status", function(res) {
    if (typeof res.status != "undefined") {
        active = res.status;
        
        if (!active) {
            chrome.browserAction.setIcon({ path: "kitty_key_off.png" });
        }
        
        updateTabs();
    }
});

chrome.runtime.onInstalled.addListener(function(details) {
    chrome.tabs.query({}, function(tabs) {
        tabs.forEach(function(tab) {
            if (/^(http|https):\/\//.test((tab.url).toString())) {
                chrome.tabs.executeScript(tab.id, {file: "res/js/main.js"});            
            }
        });        
    });    
});