var au = null;
var auID = "kittykeys-audio-id-jid1-PLMIcWpN2jc0fg";
var active = false;
var img = null;
var imgShown = false;
var footprintID = "kittykeys-id-jid1-PLMIcWpN2jc0fg";
        
var meow = {
    init: function() {
        window.addEventListener("keypress", meow.keypress, true);
        
        meow.update();
        meow.createAudio();
        meow.createImg();
        meow.setupCombo();

        if (!document.getElementById(footprintID)) {
            var footprint = document.createElement("div");
            footprint.id = footprintID;
            document.body.appendChild(footprint);
        }
    },
    
    setupCombo: function() {
        var combos = ["meow", "cat"];
        var keys = [];
        
        for (var i = 0; i < combos.length; i++) {
            keys[i] = [];
        }
        
        window.addEventListener("keypress", function(ev) {
            if (!imgShown) {             
                for (var i = 0; i < combos.length; i++) {
                    if (ev.charCode == combos[i].charCodeAt(keys[i].length)) {
                        keys[i].push(String.fromCharCode(ev.charCode));            
                    } else {
                        keys[i] = [];
                    }
                    
                    var word = keys[i].join('');

                    if (combos[i] == word) {
                        meow.showImg();
                        imgShown = true;
                        
                        setTimeout(function() {
                            meow.hideImg();
                            imgShown = false;
                        }, 1000);
                        
                        keys[i] = [];
                    }
                }
            }
        }, true);
    },
    
    keypress: function(ev) {
        if (active) {            
            var key = ev.charCode;
            var map = {
                "33": "exclamation",
                "48": "0",
                "49": "1",
                "50": "2",
                "51": "3",
                "52": "4",
                "53": "5",
                "54": "6",
                "55": "7",
                "56": "8",
                "57": "9",
                "52": "4",
                "53": "5",
                "63": "question",
                "101": "e",
                "109": "m",
                "111": "o",   
                "119": "w",                 
            }
            
            if (typeof map[key] != "undefined") {
                meow.play(map[key]);
            }

        }
    },
    
    createAudio: function() {
        var auEl = document.getElementById(auID);
        
        if (!auEl) {
            au = document.createElement("audio");
            au.id = auID;
            document.body.appendChild(au);
        }
    },
    
    play: function(sound) {
        var ext = ".wav";
        
        if (au) {
            try {
                au.src = chrome.extension.getURL("res/snd/" + sound + ext);
                au.autoplay = true;
            } catch (ex) {}
        }
    },
    
    update: function(status) {
        chrome.runtime.sendMessage({ type: "getStatus" }, function(response) {
            active = response.status;
        });
    },

    createImg: function() {
        var imgID = "kittykeys-splash-combo";
        var eximg = document.getElementById(imgID);
        
        if (eximg) {
            eximg.parentNode.removeChild(eximg);
        }
        
        img = document.createElement("img");
        img.src = chrome.extension.getURL("res/img/kitty_keys_logo.gif");
        img.id = imgID;
        img.style.position = "fixed";
        img.style.top = "50%";
        img.style.left = "50%";        
        img.style.marginTop = "-91px";      
        img.style.marginLeft = "-82px";
        img.style.display = "none";
        img.style.zIndex = "99999";
        
        document.body.appendChild(img);    
    },
    
    showImg: function() {
        if (img && active) {
            img.style.display = "block";
        }
    },
    
    hideImg: function() {
        if (img) {
            img.style.display = "none";
        }
    },
}

meow.init();

chrome.runtime.onMessage.addListener(function(msg) {
    switch (msg.event) {
        case "update":
            active = msg.status;
            break;            
    }
});
